<template>
  <div id="wrapper">
    <header>
      <div class="header-cell-left">LISTED COMPANIES (VUE)</div>
      <div class="header-cell-right">
        <strong>{{ username }}</strong> |
        <span @click="logout">logout</span>
      </div>
    </header>
    <main>
      <div class="items">
        <div class="item-fluid">
          <div class="item-100-center">
            <h1>Listed Companies</h1>
          </div>
        </div>
        <div className="item-fluid">
          <div className="item-100-center">
            <button @click="() => (chartVisible = !chartVisible)">
              {{ chartVisible ? "Show list" : "Show chart" }}
            </button>
          </div>
        </div>
      </div>
      <section class="items" v-if="!chartVisible">
        <CompanyItem
          v-for="company in companies"
          :key="company.id"
          :company="company"
          @company-deleted="removeCompany"
          @action-completed="loadCompanies"
        />
      </section>
      <div class="items" v-if="!chartVisible">
        <div class="item-fluid">
          <div class="item-100-center">
            <button @click="openCompanyAddPopup">Lisa ettevõte</button>
          </div>
        </div>
      </div>
      <Popup
        v-if="popupOpen"
        :conf="popupConfig"
        @popup-closed="closePopup"
        @action-completed="loadCompanies"
      >
        <CompanyEdit />
      </Popup>
      <section class="items" v-if="chartVisible">
        <CompanyChart :companies="companies" />
      </section>
    </main>
    <footer>&copy; Marek Lints {{ currentYear }}</footer>
  </div>
</template>

<script>
import Popup from "./Popup.vue";
import PopupConfig from "./PopupConfig";
import CompanyItem from "./CompanyItem.vue";
import CompanyEdit from "./CompanyEdit.vue";
import CompanyChart from "./CompanyChart.vue";
import Util from "../util/Util";
import FetchApi from "../util/FetchApi";
import Auth from "../util/Auth";

export default {
  name: "Main",
  data() {
    return {
      chartVisible: false,
      popupOpen: false,
      popupConfig: PopupConfig.POPUP_CONF_DEFAULT,
      companies: null,
      currentYear: new Date().getFullYear(),
      username: Auth.getUsername(),
    };
  },
  created() {
    this.loadCompanies();
  },
  methods: {
    async loadCompanies() {
      try {
        this.companies = await FetchApi.getCompanies();
        this.closePopup();
      } catch (e) {
        Util.handleError(e, () => this.$router.push({ name: "Login" }));
      }
    },
    removeCompany(id) {
      this.companies = this.companies.filter((c) => c.id !== id);
    },
    async openCompanyAddPopup() {
      this.popupOpen = true;
    },
    closePopup() {
      this.popupOpen = false;
    },
    logout() {
      Auth.clearAuthentication();
      this.$router.push({ name: "Login" });
    },
  },
  components: {
    Popup,
    CompanyItem,
    CompanyEdit,
    CompanyChart,
  },
};
</script>